unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls, Grids, Spin, Unit2, Menus, ImgList, Math;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ListView1: TListView;
    TreeView1: TTreeView;
    BitBtn4: TBitBtn;
    SaveDialog1: TSaveDialog;
    Label3: TLabel;
    Label4: TLabel;
    PopupMenu1: TPopupMenu;
    RemoveOsoba: TMenuItem;
    NewOsoba: TMenuItem;
    BitBtn6: TBitBtn;
    Panel2: TPanel;
    BitBtn3: TBitBtn;
    BitBtn2: TBitBtn;
    ListView2: TListView;
    Label1: TLabel;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    BitBtn5: TBitBtn;
    BitBtn7: TBitBtn;
    Panel3: TPanel;
    Label5: TLabel;
    EditOsoba: TMenuItem;
    Label6: TLabel;
    ImageList1: TImageList;
    TabSheet3: TTabSheet;
    Label7: TLabel;
    PaintBox1: TPaintBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Timer1: TTimer;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure NewOsobaClick(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
    procedure EditOsobaClick(Sender: TObject);
    procedure RemoveOsobaClick(Sender: TObject);
    procedure TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
//    procedure TestovaciRodokmen;
    procedure Nacti(fn:string);
    procedure Vypln_databazi;
    procedure VlozVztah(oss : osoba_p; vztah : string);    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit3, Unit4;
{$R *.DFM}

{
procedure TForm1.TestovaciRodokmen;
var osoba : osoba_p;
begin
 ClearList(rodokmen); //novy cisty rodokmen
 rodokmen := tlist.create;
 new(osoba);
 fillchar(osoba^, sizeof(osoba_t), 0);
 osoba.id := 'i1';
 osoba.jmeno := 'jmeno';
 osoba.prijmeni := 'prijmeni';
 osoba.narozeni := 1999;
 osoba.muz := true;
 rodokmen.add(osoba);
end;
}
procedure TForm1.BitBtn4Click(Sender: TObject);
begin
 if savedialog1.execute then
  Save_XML(savedialog1.filename);
end;

procedure TForm1.Nacti(fn:string);
var osc,i : integer;
begin
 repaint;
 osc := screen.cursor;screen.cursor := crHourGlass;
 //
 if not parsexml(fn) then
  exit;
 //
 ClearList(rodokmen);
 rodokmen := tlist.create;
 rodokmen.clear;
 //prekopiruj obsah
 for i := 0 to rodokmen_l.count-1 do
 begin
  rodokmen.add(rodokmen_l.items[i]);
 end;
 rodokmen_l.free;
 rodokmen_l := nil;
 //
 Vypln_Databazi;
 //
 screen.cursor := osc;
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
 repaint;
 //
 Form4.ShowModal;
 //
 try Vypln_Databazi; except end;
 //
end;

procedure TForm1.Vypln_Databazi;
var os  : osoba_p;
    i   : integer;
    osc : integer;

//obrazky:
// 0 = nema zadne rodice
// 1 = je potomkem
// 2 = je rodicem

procedure vloz_potomstvo(komu:osoba_p;otec_:boolean);
var o : osoba_p;
    b : boolean;
    i : integer;
begin
 for i := 0 to rodokmen.count-1 do
  if assigned(rodokmen.items[i]) then
  begin
   o := rodokmen.items[i];
   if o = komu then
    continue;
   if otec_ then
   begin
    b := (o^.otec<>'')and(o^.otec = komu^.id);
   end else
   begin
    b := (o^.matka<>'')and(o^.matka = komu^.id);
   end;
   //
   if (b) then
   begin
    if (o^.treei = nil) or ((otec_=false)and(o^.matkai = false)) then
    begin
     o^.matkai := not otec_;
     o^.treei := treeview1.items.addchild(komu^.treei,o^.jmeno+' '+o^.prijmeni);
     o^.treei.ImageIndex := 1;
     o^.treei.SelectedIndex := 1;
     o^.treei.data := o;
     vloz_potomstvo(o, otec_);
    end;
   end;
  end;
end;

procedure najdi_vyssiho(komu:osoba_p;otec_:boolean);
//cilem je najit nejstarsiho rodice (ktery je nejvyse v rodokmenu)
var o : osoba_p;
begin
 if otec_ then
  o := dej_id(komu^.otec) else
  o := dej_id(komu^.matka);
 if o = komu then
  exit;
 if assigned(o) then //existuje vyssi
  begin najdi_vyssiho(o,otec_); exit; end;

 //mam nejvyssiho,popr. neexistuje otec/matka
 if not assigned(komu^.treei) then //uz jsem ho vlozil?
 begin
  komu^.treei := treeview1.items.addchild(nil,komu^.jmeno+' '+komu^.prijmeni);
  komu^.treei.data := komu;
 end;
 vloz_potomstvo(komu, otec_);
end;

begin //vyplni kartu :databaze:
 osc := screen.cursor; screen.cursor := crHourGlass;
 //
 rodokmen.pack;
 //--textova cast
 listview1.items.beginupdate;
 listview1.items.clear;
 listview2.items.clear;
 if rodokmen.count>0 then
 for i := 0 to rodokmen.count - 1 do
 begin
  os := rodokmen.items[i];
  if not assigned(os) then
   continue;
  os^.treei := nil; //dulezite pro grafickou cast
  os^.matkai := false; 
  os^.listi := listview1.Items.Add;
  os^.listi.Data := os;
  os^.listi.caption := os^.id;
  os^.listi.SubItems.add(os^.jmeno);
  os^.listi.SubItems.add(os^.prijmeni);
  if os^.muz then
   os^.listi.SubItems.add('M') else
   os^.listi.SubItems.add('Z');
  if os^.narozeni > 0 then
   os^.listi.SubItems.add(inttostr(os^.narozeni)) else
   os^.listi.SubItems.add('nezjisteno');
  if os^.umrti > 0 then
   os^.listi.SubItems.add(inttostr(os^.umrti)) else
   os^.listi.SubItems.add('zije...');
 end;
 listview1.items.endupdate;
 //--graficka cast
 treeview1.items.beginupdate;
 treeview1.items.clear;
 //-pro linii otce
 if rodokmen.count>0 then
 for i := 0 to rodokmen.count - 1 do
 begin
  os := rodokmen.items[i];
  if not assigned(os) then
   continue;
  najdi_vyssiho(os,true);
 end;
 //-pro linii matky
 if rodokmen.count>0 then
 for i := 0 to rodokmen.count - 1 do
 begin
  os := rodokmen.items[i];
  if not assigned(os) then
   continue;
  najdi_vyssiho(os,false);
 end;
 //-nastav spravne obrazky
 if rodokmen.count>0 then
 for i := 0 to rodokmen.count - 1 do
 begin
  os := rodokmen.items[i];
  if (not assigned(os))or(not assigned(os^.treei)) then
   continue;
  if (os^.treei.haschildren)and(assigned(os^.treei.parent)) then
  begin
   os^.treei.imageindex := 3;
   os^.treei.selectedindex := 3;
  end else
  if os^.treei.haschildren then
  begin
   os^.treei.imageindex := 2;
   os^.treei.selectedindex := 2;
  end else
  if assigned(os^.treei.parent) then
  begin
   os^.treei.imageindex := 1;
   os^.treei.selectedindex := 1;
  end else
  begin
   os^.treei.imageindex := 0;
   os^.treei.selectedindex := 0;
  end;
 end;
 //
 treeview1.fullexpand;
 treeview1.items.endupdate;
 //konec
 screen.cursor := osc;
end;

procedure TForm1.VlozVztah(oss : osoba_p; vztah : string);
var li : tlistitem;
begin
  if assigned(oss) then
  begin
   li := listview2.items.add;
   li.caption := oss^.id;
   li.subitems.add(oss^.jmeno);
   li.subitems.add(oss^.prijmeni);
   li.subitems.add(vztah);
  end;
end;


procedure TForm1.ListView1SelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
var
    os  : osoba_p;
    os1 : osoba_p;
    osc : integer; //old screen.cursor
    i   : integer;
begin
 listview2.items.clear;
 bitbtn2.enabled := selected;
 bitbtn5.enabled := selected;
 bitbtn7.enabled := selected;
 label1.caption := 'Vybran poloka m vazby na:';
 if selected = false then //kdyz nic neni, nic nedelam
  exit;
 //
 osc := screen.cursor;screen.cursor := crHourGlass;
 //zjisti osobu
 os := ListView1.Selected.data;
 if not assigned(os) then
  exit;
 //vztahy
 //otec/matka
 os1 := dej_id(os^.matka);
 VlozVztah(os1, 'MATKA');
 os1 := dej_id(os^.otec);
 VlozVztah(os1, 'OTEC');
 //
 for i := 0 to rodokmen.count-1 do
 begin
  os1 := rodokmen.items[i];
  if (not assigned(os1))or(os1 = os) then
   continue;
  //sourozenci
  if (assigned(dej_id(os^.matka)))and(dej_id(os^.matka) = dej_id(os1^.matka)) then
   VlozVztah(os1, 'SOUROZENEC') else
  if (assigned(dej_id(os^.otec)))and(dej_id(os^.otec) = dej_id(os1^.otec)) then
   VlozVztah(os1, 'SOUROZENEC') else
  //dite
  if (dej_id(os1^.otec) = os)or(dej_id(os1^.matka) = os) then
   VlozVztah(os1, 'DITE');
 end;


 //
 screen.cursor := osc;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
 new_os := nil; //tvorim novou
 if form3.showmodal = mrOk then
 begin
  rodokmen.add(new_os);
  rodokmen.pack;
  Vypln_databazi;
 end;
end;

procedure TForm1.BitBtn7Click(Sender: TObject);
begin
 new_os := listview1.selected.data; //upravuji
 if not assigned(new_os) then
  begin bitbtn7.enabled := false; exit; end;
 //
 if form3.showmodal = mrOk then
  Vypln_databazi;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 if not assigned(listview1.selected) then
  begin bitbtn2.enabled := false; exit; end;
 if assigned(listview1.selected.data) then
 begin
  try rodokmen.Remove(listview1.selected.data); except end;
  try dispose(listview1.selected.data); except end;
 end;
 listview1.items.Delete(listview1.selected.Index);
end;


procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 if opendialog1.execute then
 begin
  if ansiuppercase(ExtractFileExt(opendialog1.filename)) <> '.XML' then
   showmessage('Pokousite se nacist jiny soubor nez XML. Pokud soubor neobsahuje info o rodokmenu, bude stavajici rodokmen zrusen.');
  nacti(opendialog1.filename);
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
// nacti('C:\Documents and Settings\ictk\Plocha\vzory\adams.xml');
 rodokmen := tlist.create;
 rodokmen.clear;
 //
 pagecontrol1.activepage := tabsheet1;
 //
 tabsheet3.doublebuffered := true;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
var os : osoba_p;
    o1 : osoba_p;
    i  : integer;
    rozdil : integer;
    cnt    : integer;
begin
 if (rodokmen.count < 0)or(not assigned(listview1.selected))or (not assigned(listview1.selected.data)) then
  exit;
 //
 o1 := listview1.selected.data;
 if (o1^.umrti>0) then
  begin
   if messagebox(handle,'Pro mrtveho? Mam hledat nebo ne?','dotaz',mb_iconquestion or mb_yesno)=id_no then
    exit;
  end;
 if (o1^.narozeni <=0) then
  begin
   messagebox(handle,'Ale vzdyt neznam jeho narozeni!','chyba',mb_iconquestion or mb_yesno);
   exit;
  end;
 //
 listview2.items.clear;
 cnt := 0;
 label1.caption := 'Vsledky hledn:';
 for i := 0 to rodokmen.count - 1 do
 if assigned(rodokmen.items[i]) then
 begin
  os := rodokmen.items[i];
  //nechci mrtvoly
  if (os^.narozeni <= 0)or(os^.umrti > 0) then
   continue;
  //rozdil veku
  rozdil := abs(os^.narozeni - o1^.narozeni);
  if rozdil > spinedit1.value then
   continue;
  //sourozenci maji stejneho otce nebo matku
  if (assigned(dej_id(os^.matka)))and(dej_id(os^.matka) = dej_id(o1^.matka)) then
    continue;
  if (assigned(dej_id(os^.matka)))and(dej_id(os^.otec) = dej_id(o1^.otec)) then
    continue;
  //rozdilne pohlavi (nic proti parum stejneho pohlavi, ale nevim jak bych to konzultoval se zadanim...)
  if os^.muz = o1^.muz then
   continue;
  //
  VlozVztah(os, inttostr(rozdil)+' let');
  inc(cnt);
 end;
 if cnt = 0 then
  messagebox(handle,'Nikoho vhodneho jsem nenasel.','info',mb_iconwarning or mb_ok);
end;

procedure TForm1.TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
 accept := Source is TTreeView;
end;

procedure TForm1.TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
var 
  AnItem: TTreeNode;
  AttachMode: TNodeAttachMode;
  HT: THitTests;
begin
  AttachMode := naAddChild;
  if TreeView1.Selected = nil then Exit;
  HT := TreeView1.GetHitTestInfoAt(X, Y);
  AnItem := TreeView1.GetNodeAt(X, Y);
  if TreeView1.Selected = AnItem then begin messagebeep(mb_iconhand); Exit; end;
  if (HT - [htOnItem, htOnIcon, htNowhere, htOnIndent] <> HT) then
  begin
    if (htOnItem in HT) or (htOnIcon in HT) then AttachMode := naAddChild
    else if htNowhere in HT then AttachMode := naAdd
    else if htOnIndent in HT then AttachMode := naInsert;
    //uprav ID
    if (AttachMode = naAdd)or(AttachMode = naInsert) then
    begin //nastav stejne rodice, protoze je na stejne urovni
     osoba_p(TreeView1.selected.data)^.otec := osoba_p(AnItem.data)^.otec;
     osoba_p(TreeView1.selected.data)^.matka := osoba_p(AnItem.data)^.matka;
    end else
    begin //nastav mi AnItem jako rodice
     if osoba_p(AnItem.data)^.muz then
      osoba_p(TreeView1.selected.data)^.otec := osoba_p(AnItem.data)^.id else
      osoba_p(TreeView1.selected.data)^.matka := osoba_p(AnItem.data)^.id;      
    end;
    //
    TreeView1.Selected.MoveTo(AnItem, AttachMode);
    //
    Vypln_databazi; 
  end;
end;

procedure TForm1.NewOsobaClick(Sender: TObject);
begin
 BitBtn3.Click;
end;

procedure TForm1.TreeView1Click(Sender: TObject);
var os : osoba_p;
begin
 label5.caption := '---';
 RemoveOsoba.enabled := assigned(treeview1.selected);
 EditOsoba.enabled := assigned(treeview1.selected);
 if not assigned(treeview1.selected) then
  exit;
 os := treeview1.selected.data;
 if not assigned(os) then
  exit;
 Label5.Caption := os^.id+':  Narozeni: '+inttostr(os^.narozeni)+'  Umrti: '+inttostr(os^.umrti);
end;

procedure TForm1.EditOsobaClick(Sender: TObject);
begin
 new_os := treeview1.selected.data;
 if not assigned(new_os) then
  begin EditOsoba.Enabled := false; exit; end;
 if form3.showmodal = mrOk then
  Vypln_databazi;
end;

procedure TForm1.RemoveOsobaClick(Sender: TObject);
var os : osoba_p;
begin
 os := treeview1.selected.data;
 if not assigned(os) then
  begin RemoveOsoba.Enabled := false; exit; end;
 try rodokmen.remove(os); except end;
 try dispose(os); except end;
 Vypln_databazi;
end;


procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 imagelist1.draw(paintbox1.canvas,0,0,0,true);
 imagelist1.draw(paintbox1.canvas,0,32,1,true);
 imagelist1.draw(paintbox1.canvas,0,64,2,true);
 imagelist1.draw(paintbox1.canvas,0,96,3,true); 
end;

procedure TForm1.Timer1Timer(Sender: TObject);
const u : integer = -30;
var   i : integer;
begin
  //AN: je treba nejak vyuzit volne misto stranky ;)
 label12.left := 0 + u + round(sin(degtorad(u)) * 30);
 label12.top := 320 + round(cos(degtorad(u)) * 30);
 //barva
 i := u;
 while i > 180 do
  i := i - 180;
 if i < 90 then
  i := round( 255 - u * (255 / 180) ) else
  i := round( u * (255 / 180) );
 if i > 200 then i := 200;
 label12.font.color := RGB(i,i,i);
 //novy uhel
 inc(u,5);
 if u>680 then
  u := -30;
end;

end.
