unit Unit2;
interface

uses windows, classes, sysutils, comctrls;

//AN: vsechna ID budou prevedena do LowerCase
//    muz = false --->>> je to zena
//    hodnota '' nebo 0 znamena, ze dana polozka tagu nebyla nalezena

type
  osoba_p = ^osoba_t;
  osoba_t = record
   id : string;
   jmeno : string;
   prijmeni : string;
   muz : boolean;
   narozeni : dword;
   umrti : dword;
   matka : string;
   otec : string;
   //
   listi : tlistitem;
   treei : ttreenode;
   //
   matkai : boolean; //pro rekurzivni vyplnovani
  end;

var
  rodokmen : tlist;

  rodokmen_l : tlist;

function ParseXML(fn:string):boolean;
procedure Save_XML(fn : string);

function dej_id(id:string):osoba_p;

procedure ClearList(var l:tlist);

implementation

var
 sz   : dword;
 buf  : ansistring;
 bufp : dword; //pozice v buf

function my_getfilesize(fn:string):dword;
var ff : file;
begin
 assign(ff,fn);
 reset(ff,1);
 try
  result := filesize(ff);
 finally
  closefile(ff);
 end;
end;

function najdi_tag(tag:string):boolean;
var i,j : dword;
      b : boolean; 
begin
 //prohleda buf a najde tag, pokud ho najde, nastavi result na true
 //a nastavi pozici v bufferu za posledni pismeno tagu
 result := false;
 tag := uppercase(tag);
 for i := bufp to sz - length(tag) do
 begin
  b := true;
  for j := 1 to length(tag) do
   if tag[j] <> upcase(buf[i+j-1]) then
    begin b := false; break; end;
  if b = true then
  begin //nasel
   bufp := i + length(tag);
   result := true;
   exit;
  end;
 end;
end;

var crash : boolean;

procedure chyba_xml(tag:string);
var s : string;
begin
 s := 'Nenalezen tag "'+tag+'", i kdy bzl oekvn!'#0;
 messagebox(0,@s[1],'zpracuj_tag_osaba - Chyba!',mb_iconhand or mb_ok);
 crash := true;
end;

function dej_tag(tag:string):string;
var i, old_bufp : dword;
begin
 result := '';
 old_bufp := bufp;
 //
 if not najdi_tag('<'+tag) then
  begin
   bufp := old_bufp;
   exit;
  end;
 //test na pritomnost polozky v tagu "osoba"
  //bufp ted ukazuje na polozku nekde v bufferu
  //ale musi byt mensi nez nejblizsi ukoncovaci tag </osoba>, jinak
  //tato polozka nepatri do prave parsovaneho tagu osoba
  i := bufp;
  bufp := old_bufp;
  najdi_tag('</osoba>');
  if i > bufp then
   begin
    bufp := old_bufp;
    exit;
   end;
 bufp := i;  
 //test na prazdnou polozku
 while (not (buf[bufp] in ['/','>'])) and (bufp < sz-1) do
  begin
   inc(bufp);
  end;
 if buf[bufp] = '/' then
  begin
   bufp := old_bufp;
   exit;
  end; 
 bufp := old_bufp;
 //
 if najdi_tag('<'+tag+'>') then
 begin
  old_bufp := bufp;
  if not najdi_tag('</'+tag+'>') then
   begin chyba_xml('</'+tag+'>'); exit; end;
  result := trim(copy(buf, old_bufp, bufp - (2 + length(tag)) - old_bufp - 1));
 end;
end;

function zpracuj_tag_osoba : boolean;
var os  : osoba_p;
    s   : string;
    poz : dword;
begin
 result := false;
 //zpracuje udaje od pozice bufp v bufferu do nalezeni ukoncovaciho
 //tagu /osoba
 new(os);
 fillchar(os^, sizeof(osoba_t), 0);
 rodokmen_l.add(os);
 poz := bufp;
 //
 os^.id := uppercase(dej_tag('id'));
 if crash then exit;
 bufp := poz; os^.jmeno := dej_tag('jmeno');
 if crash then exit;
 bufp := poz; os^.prijmeni := dej_tag('prijmeni');
 if crash then exit;
 bufp := poz; s := dej_tag('pohlavi');
 if length(s)>0 then
  os^.muz := (upcase(s[1]) = 'M') else
  os^.muz := true; //ze ano
 if crash then exit;
 bufp := poz; os^.matka := uppercase(dej_tag('matka'));
 if crash then exit;
 bufp := poz; os^.otec := uppercase(dej_tag('otec'));
 if crash then exit;
 bufp := poz; s := dej_tag('narozeni');
 if crash then exit;
 try os^.narozeni := strtoint(s); except os^.narozeni := 0; end;
 bufp := poz; s := dej_tag('umrti');
 if crash then exit;
 try os^.umrti := strtoint(s); except os^.umrti := 0; end;
 //vse
 result := true;
end;

function ParseXML(fn:string):boolean;
var
    f   : file;
    ofm : integer; //old filemode
begin
 result := false;
 //
 crash := false;
 //
 if not fileexists(fn) then
  begin
   messagebox(0,'Soubor nelze otevt!','ParseXML - chyba',mb_iconhand or mb_ok);
   exit;
  end;
 ofm := filemode; filemode := 0;
 //
 sz := my_getfilesize(fn);
 if sz <= 1 then
  begin
   messagebox(0,'Neplatn velikost souboru!','ParseXML - chyba',mb_iconhand or mb_ok);
   exit;
  end;
 //
 assignfile(f,fn);
 reset(f,1);
 //nacti buffer
 try
  setlength(buf, sz);
  blockread(f, buf[1], sz);
 finally
  closefile(f);
  filemode := ofm;
 end;
 //zpracuj
 bufp := 1; //prvni znak
 if not najdi_tag('<rodokmen>') then
  begin
   messagebox(0,'Nenalezen tag "rodokmen_l"!','ParseXML - chyba',mb_iconhand or mb_ok);
   exit;
  end;
 //
 ClearList(rodokmen_l);
 rodokmen_l := tlist.create;
 rodokmen_l.clear;
 while najdi_tag('<osoba>') do
 begin
  if not zpracuj_tag_osoba then
  begin
   ClearList(rodokmen_l); //je to naplatny XML -> neplatny rodokmen_l
   break;
  end;
 end;
 //
 if rodokmen_l.count <= 0 then
 begin
   messagebox(0,'Nenalezen zadny tag "osoba"!','ParseXML - chyba',mb_iconhand or mb_ok);
   exit;
 end;
 //konec
 result := true;
 setlength(buf, 1); //uvolni pamet stringu
end;

procedure Save_XML(fn : string);
var
    ofm : integer; //old filemode
    f   : text;
    i   : integer;
    s   : string;

 procedure uloz_osobu(os:osoba_p);
  procedure uloz(tag,s:string);
  begin
   if length(s) < 1 then
    begin writeln(f,'<'+tag+' />');exit;end;
   writeln(f,'<'+tag+'>'+s+'</'+tag+'>');
  end;
 begin
  writeln(f,'<osoba>');
  uloz('id',os^.id);
  uloz('jmeno',os^.jmeno);
  uloz('prijmeni',os^.prijmeni);
  if os^.muz then s := 'M' else s := 'Z';
  uloz('pohlavi',s);
  if os^.umrti <=0 then s:='' else s := inttostr(os^.umrti);
  uloz('umrti',s);
  if os^.narozeni <=0 then s:='' else s := inttostr(os^.narozeni);
  uloz('narozeni',s);
  uloz('matka',os^.matka);
  uloz('otec',os^.otec);
  writeln(f,'</osoba>');
 end;

begin
 if fileexists(fn) then
  begin
   messagebox(0,'Soubor existuje, bude pepsn!','Save_XML',mb_ok);
  end;
 ofm := filemode; filemode := 0;
 //
 assignfile(f,fn);
 rewrite(f);
 try
  writeln(f,'<rodokmen>');
  writeln(f,'<generator>33</generator>');
  writeln(f,'<date>'+DateToStr(Now)+'</date>');
  if rodokmen.count>0 then
  for i := 0 to rodokmen.count-1 do
   if assigned(rodokmen.items[i]) then
    uloz_osobu(rodokmen.items[i]);
  writeln(f,'</rodokmen>');
 finally
  closefile(f);
  filemode := ofm;
 end;
end;

procedure ClearList(var l:tlist);
var i : integer;
begin
 if not assigned(l) then
  exit;
 for i := 0 to l.count-1 do
  if assigned(l.items[i]) then
   try dispose(l.items[i]); except end;
 l.free;
 l := nil;
end;

function dej_id(id:string):osoba_p;
var i : integer;
begin
 result := nil;
 if (not assigned(rodokmen))or(rodokmen.count<1) then
  exit;
 //
 id := uppercase(id);
 for i := 0 to rodokmen.count-1 do
  if assigned(rodokmen.items[i]) then
   if osoba_p(rodokmen.items[i])^.id = id then
   begin
    result := rodokmen.items[i];
    exit;
   end;
end;


end.
